import 'dart:convert';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:bui_component/MultiStageComponent/json_schema.dart';
import 'package:example/Constants/AppColors.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:flutter/material.dart';
import 'package:example/Models/account_details_bean.dart';
import 'package:example/Constants/server_url.dart';
import 'package:example/network/api_service.dart';
import 'package:toast/toast.dart';
import 'package:bui_component/ButtonsComponent/buttonComponent.dart';
import 'package:example/Constants/AppColors.dart';
import 'package:example/Utils/loader.dart';

class ViewMoreScreen extends StatefulWidget {
  String pageTitle;
  String email;
  String firstName;
  String id;
  Color theme;

  AccountListBean accountListBeanData;

  ViewMoreScreen(
      {Key key, this.pageTitle, this.accountListBeanData, this.theme})
      : super(key: key);

  @override
  ViewMoreScreenState createState() => ViewMoreScreenState(
      pageTitle: pageTitle,
      email: email,
      firstName: firstName,
      id: id,
      accountListBeanData: accountListBeanData);
}

class ViewMoreScreenState extends State<ViewMoreScreen> {
  String pageTitle;
  String email;
  String firstName;
  String id;
  AccountListBean accountListBeanData;

  dynamic formGeneral;

  ViewMoreScreenState(
      {this.pageTitle,
      this.email,
      this.firstName,
      this.id,
      this.accountListBeanData}) {}

  String name = "Test";
  String form;

  dynamic response;

  Color theme = AppColors.APP_COLOR_PRIMARY;

  bool isLoader = true;

  SharedPreferences prefs;

  Map decorations;

  Map validations = {'text1': validationExample};
  Map errorText = {
    'input1': "Error Value",
    'text1': "Enter the Password",
  };

  static String validationExample(field, value) {
    String pattern =
        r'^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[0-9])(?=.*?[!@#\$&*~]).{8,}$';
    RegExp regExp = new RegExp(pattern);

    if (value.isEmpty) {
      return 'Please enter some text';
    }
    if (value.length < 8) {
      return 'Password is too short';
    }

    if (!regExp.hasMatch(value)) {
      return 'Password contains Minimum 1 Upper case Minimum 1 lowercase Minimum 1 Numeric Number Minimum 1 Special Character Common Allow Character ( ! @ # \$ & * ~ )';
    }
    return null;
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    getStringValuesSF();

    form = json.encode({
      //'title': 'Test Form Json Schema',
      //'description': 'My Description',
      'autoValidated': false,
      'fields': [
        {
          'key': 'Company Name',
          'type': 'input',
          'label': 'Company Name',
          'required': false,
          'readOnly': true,
          'keyboardType': 'text',
          'validator': 'text',
          'value': accountListBeanData.companyname.toString() != "null"
              ? accountListBeanData.companyname.toString()
              : "",
        },
        {
          'key': 'Status',
          'type': 'input',
          'label': 'Status',
          'required': false,
          'keyboardType': 'text',
          'validator': 'text',
          'value': firstName ?? null,
        },
        {
          'key': 'Industry',
          'type': 'input',
          'label': 'Industry',
          'required': false,
          'keyboardType': 'text',
          'validator': 'text',
          //        'value': accountListBeanData.industry ?? null,
        },
        {
          'key': 'No of Employees',
          'type': 'input',
          'label': 'No of Employees',
          'required': false,
          'keyboardType': 'number',
          'validator': 'text',
          'value': accountListBeanData.noofemployees.toString() != "null"
              ? accountListBeanData.noofemployees.toString()
              : "",
        },
        {
          'key': 'Annual Revenue',
          'type': 'input',
          'label': 'Annual Revenue',
          'required': false,
          'keyboardType': 'number',
          'validator': 'text',
          'value': accountListBeanData.annualrevenue.toString() != "null"
              ? accountListBeanData.annualrevenue.toString()
              : "",
        },
        {
          'key': 'input1',
          'type': 'email',
          'label': 'Email',
          'placeholder': "Enter Your Username",
          'required': 'True',
          'keyboardType': 'email',
          'value': accountListBeanData.email.toString() != "null"
              ? accountListBeanData.email.toString()
              : "",
        },
        {
          'key': 'Phone',
          'type': 'input',
          'label': 'Phone Number',
          'required': false,
          'keyboardType': 'text',
          'validator': 'text',
          'value': accountListBeanData.phone.toString() != "null"
              ? accountListBeanData.phone.toString()
              : "",
        },
        {
          'key': 'Website',
          'type': 'input',
          'label': 'Website',
          'required': false,
          'keyboardType': 'text',
          'validator': 'text',
          'value': accountListBeanData.website.toString() != "null"
              ? accountListBeanData.website.toString()
              : "",
        },
        {
          'key': 'Area',
          'type': 'input',
          'label': 'Area',
          'required': false,
          'keyboardType': 'text',
          'validator': 'text',
          'value': accountListBeanData.area.toString() != "null"
              ? accountListBeanData.area.toString()
              : "",
        },
        {
          'key': 'Address Line 1',
          'type': 'input',
          'label': 'Address Line 1',
          'required': false,
          'keyboardType': 'text',
          'validator': 'text',
          'value': accountListBeanData.address1.toString() != "null"
              ? accountListBeanData.address1.toString()
              : "",
        },
        {
          'key': 'Address Line 2',
          'type': 'input',
          'label': 'Address Line 2',
          'required': false,
          'keyboardType': 'text',
          'validator': 'text',
          'value': accountListBeanData.address2.toString() != "null"
              ? accountListBeanData.address2.toString()
              : "",
        },
        {
          'key': 'Pincode',
          'type': 'input',
          'label': 'Pincode ',
          'required': false,
          'keyboardType': 'text',
          'validator': 'text',
          'value': accountListBeanData.pincode.toString() != "null"
              ? accountListBeanData.pincode.toString()
              : "",
        },
        {
          'key': 'State',
          'type': 'input',
          'label': 'State ',
          'required': false,
          'keyboardType': 'text',
          'validator': 'text',
          'value': accountListBeanData.state.toString() != "null"
              ? accountListBeanData.state.toString()
              : "",
        },
        {
          'key': 'Country',
          'type': 'input',
          'label': 'Country ',
          'required': false,
          'keyboardType': 'text',
          'validator': 'digitsOnly',
          'value': accountListBeanData.country.toString() != "null"
              ? accountListBeanData.country.toString()
              : "",
        },
      ]
    });

    decorations = {
      'input1': InputDecoration(
        fillColor: AppColors.appWhite,
        prefixIcon: Icon(
          Icons.email,
          color: widget.theme ?? AppColors.APP_COLOR_PRIMARY,
        ),
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Company Name': InputDecoration(
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Status': InputDecoration(
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Industry': InputDecoration(
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'No of Employees': InputDecoration(
        prefixIcon: Icon(
          Icons.people_rounded,
          color: widget.theme ?? AppColors.APP_COLOR_PRIMARY,
        ),
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Annual Revenue': InputDecoration(
        prefixIcon: Icon(
          Icons.money,
          color: widget.theme ?? AppColors.APP_COLOR_PRIMARY,
        ),
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Phone': InputDecoration(
        prefixIcon: Icon(
          Icons.phone_iphone_rounded,
          color: widget.theme ?? AppColors.APP_COLOR_PRIMARY,
        ),
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Website': InputDecoration(
        prefixIcon: Icon(
          Icons.web_rounded,
          color: widget.theme ?? AppColors.APP_COLOR_PRIMARY,
        ),
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Area': InputDecoration(
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Address Line 1': InputDecoration(
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Address Line 2': InputDecoration(
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'State': InputDecoration(
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Pincode': InputDecoration(
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
      'Country': InputDecoration(
        focusedBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(color: widget.theme ?? AppColors.halfWhite, width: 2),
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.halfWhite,
            width: 2.0,
          ),
        ),
        errorBorder: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
        border: OutlineInputBorder(
          borderRadius: BorderRadius.circular(7.0),
          borderSide: BorderSide(
            color: AppColors.errorWarning,
            width: 2.0,
          ),
        ),
      ),
    };
  }

  getStringValuesSF() async {
    prefs = await SharedPreferences.getInstance();
    String stringValue = prefs.getString('stringValue');

    if (stringValue != null) {
      int colorCodeInt = int.parse(stringValue);
      setState(() {
        theme = Color(colorCodeInt);
        this.mounted;
        isLoader = false;
      });
    } else {
      setState(() {
        isLoader = false;
        theme = AppColors.APP_COLOR_PRIMARY;
        this.mounted;
      });
    }
  }

  @override
  Widget build(BuildContext context) {
    return new Scaffold(
      appBar: AppBar(
        backgroundColor: theme ?? AppColors.primaryColor,
        title: Text(pageTitle ?? "Form"),
      ),
      body: new SingleChildScrollView(
        child: isLoader
            ? Center(
                child: Loader(
                  loaderColor: theme,
                ),
              )
            : Form(
                //key: _formkey,
                child: new Center(
                  child: new Column(children: <Widget>[
                    new JsonSchema(
                      theme: theme ?? AppColors.primaryColor,
                      calendarColor: AppColors.APP_COLOR_PRIMARY,
                      decorations: decorations,
                      form: form,
                      validations: validations,
                      errorMessages: errorText,
                      onChanged: (dynamic response) {
                        this.response = response;
                      },
                      actionSave: (data) {
                        setState(() {
                          formGeneral = data;
                        });

                        var jsonObj = {
                          for (int i = 0; i < data['fields'].length; i++)
                            data['fields'][i]['label']
                                .toLowerCase()
                                .trimRight(): json.encode(data['fields'][i]
                                    ['value']
                                .toString()
                                .trimLeft())
                        };
                        String jsonObject =
                            jsonObj.toString().replaceAll(' ', '');

                        updateValue(jsonObject.toString());
                      },
                      actionCancel: () {

                        Navigator.pop(context);
                      },
                      //autovalidateMode: AutovalidateMode.onUserInteraction,
                      buttonSave: true,
                    ),
                  ]),
                ),
              ),
      ),
    );
  }

  Future<void> updateValue(String jsonString) async {
    /*  jsonString = jsonString.replaceAll("{", "");
     jsonString = jsonString.replaceAll("}", "");*/

    String urlController = ServerUrl.UPDATE_ACCOUNT_URL;
    var objToSend = {
      "\"condition\"": [
        {"\"id\"": 1}
      ],
      "\"data\"": [jsonString.toString()]
    };

    String jsonStr = objToSend.toString();

    String res = await APIClient.getInstance().callAPI(
        context, urlController, HTTPMethod.POST,
        isHeader: true, requestBody: jsonStr);
    Map map = jsonDecode(res);
    Toast.show(map.toString(), context);
  }
}
